<template>
  <div class="add-modal">
    <el-dialog
      v-model="dialogFormVisible"
      title="Add card"
      @close="closeDialog('addCardForm')"
    >
      <el-form
        :model="form"
        ref="addCardForm"
        :rules="rules"
        label-width="120px"
        class="add-card-form"
      >
        <el-form-item
          label="Card name"
          :label-width="formLabelWidth"
          prop="cardName"
        >
          <el-input v-model="form.cardName" autocomplete="off"></el-input>
        </el-form-item>
      </el-form>
      <template #footer>
        <span class="dialog-footer">
          <el-button @click="closeDialog('addCardForm')" plain
            >Cancel</el-button
          >
          <el-button plain type="success" @click="submitForm('addCardForm')">
            Confirm
          </el-button>
        </span>
      </template>
    </el-dialog>
  </div>
</template>

<script>
import { mapActions } from 'vuex';
export default {
  name: 'AddModal',
  props: {
    formVisible: {
      type: Boolean,
    },
  },
  watch: {
    formVisible(val) {
      this.dialogFormVisible = val;
    },
  },
  data: () => {
    return {
      dialogFormVisible: false,
      formLabelWidth: '140px',
      form: {
        cardName: '',
      },
      rules: {
        cardName: [
          {
            required: true,
            message: 'Please input card name',
            trigger: 'blur',
          },
        ],
      },
    };
  },
  created() {
    this.dialogFormVisible = this.formVisible;
  },
  methods: {
    ...mapActions('card', ['setCards']),
    submitForm(formName) {
      this.$refs[formName].validate((valid) => {
        if (valid) {
          const newCard = this.dummyData(this.form.cardName);
          console.log(newCard);
          this.setCards(newCard);
          this.closeDialog();
        } else {
          console.log('error submit!!');
          return false;
        }
      });
    },
    closeDialog(formName) {
      this.$emit('close-dialog');
      this.$refs[formName].resetFields();
    },
    dummyData(cardName) {
      const cvv = this.randomNumber(3);
      const cardNumber = this.randomNumber(16).toString();
      const expire = this.randomDate(new Date(), new Date(2030, 0, 1));
      const backgroundColor = this.randomColor();

      const data = {
        id: Math.random().toString(),
        cardName,
        cvv,
        cardNumber,
        expire,
        backgroundColor,
      };
      return data;
    },
    randomNumber(n) {
      return (
        Math.floor(Math.random() * 9 * Math.pow(10, n - 1)) +
        Math.pow(10, n - 1)
      );
    },
    randomDate(start, end) {
      const date = new Date(
        start.getTime() + Math.random() * (end.getTime() - start.getTime()),
      );
      const month = (date.getMonth() + 1).toString().padStart(2, '0');
      const year = date.getFullYear();
      return `${month}/${year}`;
    },
    randomColor() {
      const colors = ['#01D167', '#536dff', '#01D167', '#536dff'];
      const random = Math.floor(Math.random() * colors.length);
      return colors[random];
    },
  },
};
</script>

<style lang="scss">
.add-modal {
  .el-dialog {
    width: 90%;
    border-radius: 8px;
  }
  .el-form-item__label {
    color: $-dark-blue;
  }
}
</style>
